=== debian/changelog ===
belle-sip (4.4.21+dfsg-2) unstable; urgency=medium

  * Cherry-pick upstream patch to fix build issue (Closes: #1012901).
  * d/rules: Temporarily relax pointer type compatibility check.

 -- Dennis Filder <d.filder@web.de>  Sun, 14 Aug 2022 12:32:04 +0000

belle-sip (4.4.21+dfsg-1) unstable; urgency=medium

  * Team upload.
  * Release to unstable
  * New upstream version 4.4.21+dfsg
  * Drop Daniel Gnoutcheff from Uploaders
  * Drop Mark Purcell from Uploaders
  * Add myself to uploaders
  * Have libbellesip-dev depend on libbctoolbox-dev (Closes: #977556)

 -- Bernhard Schmidt <berni@debian.org>  Fri, 25 Dec 2020 17:09:09 +0100

belle-sip (4.4.13+dfsg-1) experimental; urgency=medium

  * Team upload.
  * New upstream version 4.4.13+dfsg
  * Bump to debhelper-compat (= 12)
  * Change Vcs-* to linphone-stack subgroup
  * Drop obsolete no-upstream-changelog lintian override

 -- Bernhard Schmidt <berni@debian.org>  Mon, 07 Dec 2020 11:17:10 +0100

belle-sip (4.4.0+dfsg-1) experimental; urgency=medium

  * New upstream version 4.4.0+dfsg
  * Update d/copyright for switch to GPL-3+
  * Follow SONAME bump of libbellesip, tighten Build-Depends on bctoolbox

 -- Bernhard Schmidt <berni@debian.org>  Tue, 01 Sep 2020 00:19:29 +0200

belle-sip (4.3.1+dfsg-1) experimental; urgency=medium

  * Team upload.
  * New upstream version 4.3.1+dfsg (Closes: #925638)
  * d/watch: Switch to upstream primary Gitlab, only use releases
  * d/copyright, d/watch: Drop embedded antlr3c copy
  * d/p/use-system-antlr3c: build against system antrl3c
  * Drop patches applied/fixed upstream
  * Tighten libbctoolbox-dev dependency
  * Adjust for new upstream paths
  * Disable Tests, they have additional dependencies
  * Reenable all GCC warnings

 -- Bernhard Schmidt <berni@debian.org>  Mon, 01 Jun 2020 23:04:39 +0200
