## belle-sip 5.0.37+dfsg

=== debian/changelog ===
belle-sip (5.0.37+dfsg-3) unstable; urgency=medium

  * Team upload.
  * Release to unstable.

 -- Bernhard Schmidt <berni@debian.org>  Mon, 12 Sep 2022 11:55:57 +0200

belle-sip (5.0.37+dfsg-2) experimental; urgency=medium

  * Cherry-pick upstream commit d35f899 (Closes: #1012901)

 -- Dennis Filder <d.filder@web.de>  Sun, 24 Jul 2022 08:38:50 +0000

belle-sip (5.0.37+dfsg-1) experimental; urgency=medium

  [ Dennis Filder ]
  * New upstream version 5.0.37+dfsg
  * Bump to debhelper-compat (= 13)
  * Multicast DNS support is now enabled.
  * The static library is no longer shipped as part of libbellesip-dev.
    File a bug if you need it back.
  * libbellesip-dev now also depends on libbelr-dev.
  * libbellesip1 now uses DNS root server hints from dns-root-data if
    installed (Closes: #760467).

 -- Bernhard Schmidt <berni@debian.org>  Sat, 04 Dec 2021 20:30:48 +0100
