=== debian/control ===
--- 
+++ 
@@ -7,12 +7,15 @@
            Bernhard Schmidt <berni@debian.org>,
 Build-Depends: antlr3,
                cmake,
-               debhelper-compat (= 12),
+               debhelper-compat (= 13),
                intltool,
                libantlr3c-dev,
-               libbctoolbox-dev (>= 4.4.0~),
+               libavahi-compat-libdnssd-dev,
+               libbctoolbox-dev (>= 5.0.37~),
+               libbelr-dev (>= 5.0.37~),
                zlib1g-dev | libz-dev,
-Standards-Version: 4.1.4
+Standards-Version: 4.6.0
+Rules-Requires-Root: no
 Homepage: https://www.linphone.org
 Vcs-Git: https://salsa.debian.org/pkg-voip-team/linphone-stack/belle-sip.git
 Vcs-Browser: https://salsa.debian.org/pkg-voip-team/linphone-stack/belle-sip
@@ -20,8 +23,10 @@
 Package: libbellesip-dev
 Section: libdevel
 Architecture: any
-Depends: libbctoolbox-dev (>= 4.4.0~),
+Multi-Arch: same
+Depends: libbctoolbox-dev (>= 5.0.37~),
          libbellesip1 (= ${binary:Version}),
+         libbelr-dev (>= 5.0.37~),
          ${misc:Depends},
 Description: SIP stack from the Linphone team (development files)
  Belle-Sip is a new SIP stack (RFC3261) developed by the Linphone team.
@@ -39,6 +44,7 @@
 Pre-Depends: ${misc:Pre-Depends},
 Architecture: any
 Multi-Arch: same
+Recommends: dns-root-data
 Depends: ${misc:Depends},
          ${shlibs:Depends},
 Description: SIP stack from the Linphone team
